Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13712)
@@ -38,6 +38,7 @@
             try
             {
-
-                vm.userJobs = client.GetJobs();
+                HiveClientWeb.Instance.Refresh();
+
+                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
             }
             catch (Exception e)
@@ -57,13 +58,17 @@
             if (((HiveServiceLocatorWebManagerService)(HiveServiceLocatorWebManagerService.Instance)).CheckLogin())
             {
-                vm.userJobs = client.GetJobs();
-                vm.selectedJob = client.GetJob(id);
-
-                vm.lightJobTasks = client.GetLightweightJobTasks(id);
-                foreach (var light in vm.lightJobTasks)
-                {
-                    vm.filledJobTasks.Add(client.GetTask(light.Id));
-                }
-                ViewBag.Title = vm.selectedJob.Name + " - Jobs";
+                HiveClientWeb.Instance.Refresh();
+
+                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
+                foreach(var j in vm.userJobs)
+                {
+                    if(j.Id == id)
+                    {
+                        vm.selectedJob = j;
+                    }
+                }
+                vm.selectedJob.RefreshAutomatically = true;
+                HiveClientWeb.LoadJob(vm.selectedJob);
+                ViewBag.Title = vm.selectedJob.Job.Name + " - Jobs";
                 return View("Index", vm);
             }
@@ -81,5 +86,7 @@
                 vm.message = client.GetJob(id).Name + " deleted";
                 client.DeleteJob(id);
-                vm.userJobs = client.GetJobs();
+                HiveClientWeb.Instance.Refresh();
+
+                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
                 ViewBag.Title = "Jobs";
                 return View("Index", vm);
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/JobUpdaterHub.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/JobUpdaterHub.cs	(revision 13712)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/JobUpdaterHub.cs	(revision 13712)
@@ -0,0 +1,22 @@
+﻿using Microsoft.AspNet.SignalR;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Clients.Hive.WebJobManager
+{
+    public class JobUpdaterHub : Hub
+    {
+        private RefreshableJob Job;
+
+        public void initConnection(RefreshableJob j)
+        {
+            Job = j;
+        }
+        public void sendUpdate()
+        {
+            Clients.All.sendUpdate();
+        }
+    }
+}
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/AlgorithmContainer.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/AlgorithmContainer.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/AlgorithmContainer.cs	(revision 13712)
@@ -11,8 +11,10 @@
         public IAlgorithm algo { get; set; }
         public System.Random randy { get; set; }
-
-        public AlgorithmContainer(IAlgorithm al, System.Random r)
+        public List<int[]> depth { get; set; }
+        public AlgorithmContainer(IAlgorithm al, List<int[]> d, int[] v, System.Random r)
         {
             algo = al;
+            depth = d;
+            depth.Add(v);
             randy = r;
         }
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/HiveTaskContainer.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/HiveTaskContainer.cs	(revision 13712)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Models/HiveTaskContainer.cs	(revision 13712)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Clients.Hive.WebJobManager.Models
+{
+    public class HiveTaskContainer
+    {
+        public HiveTask hiveTask { get; set; }
+
+        public HiveTaskContainer(HiveTask hi)
+        {
+            hiveTask = hi;
+        }
+    }
+}
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ProgressHub.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ProgressHub.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ProgressHub.cs	(revision 13712)
@@ -21,5 +21,6 @@
         public void ChangeName(string name)
         {
-            FileOpeningService.Instance.Job.Job.Name = name;
+            if (name != null)
+                FileOpeningService.Instance.Job.Job.Name = name;
         }
         public void ToggleChild(int[][] arr)
@@ -28,16 +29,69 @@
             HiveTask current = Job.HiveTasks.ToList()[0];
             //  IOptimizer current = Job.HiveTasks.ToArray() ;
-            for (var i = 0; i < arr.Length; i++)
+            if (arr.Length == 0)
             {
-
+                current.ItemTask.ComputeInParallel = !current.ItemTask.ComputeInParallel;
                 
-                if(i == arr.Length - 1)
+            }
+            else {
+                for (var i = 0; i < arr.Length; i++)
                 {
-                    current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel;
 
 
+                    if (i == arr.Length - 1)
+                    {
+                        if (current.ItemTask.Item is BatchRun)
+                        {
+                            current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel;
+                        }
+                        else if (current.ItemTask.Item is Experiment)
+                        {
+                            current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel;
+                        }
+
+                    }
+                    else {
+                        if (current.ItemTask.Item is BatchRun)
+                            current = current.ChildHiveTasks[arr[i][1]]; // select right batch
+                        else if (current.ItemTask.Item is Experiment)
+                            current = current.ChildHiveTasks[arr[i][0]]; // select right sub task from experiment
+                    }
                 }
-                else
-                    current = current.ChildHiveTasks[arr[i][0]];
+            }
+        }
+        public void ChangePriority(int[][] arr, int prior)
+        {
+            Job = FileOpeningService.Instance.Job;
+            HiveTask current = Job.HiveTasks.ToList()[0];
+            //  IOptimizer current = Job.HiveTasks.ToArray() ;
+            if (arr.Length == 0)
+            {
+                current.Task.Priority = prior;
+
+            }
+            else {
+                for (var i = 0; i < arr.Length; i++)
+                {
+
+
+                    if (i == arr.Length - 1)
+                    {
+                        if (current.ItemTask.Item is BatchRun)
+                        {
+                            current.ChildHiveTasks[arr[i][1]].Task.Priority = prior;
+                        }
+                        else if (current.ItemTask.Item is Experiment)
+                        {
+                            current.ChildHiveTasks[arr[i][0]].Task.Priority = prior;
+                        }
+
+                    }
+                    else {
+                        if (current.ItemTask.Item is BatchRun)
+                            current = current.ChildHiveTasks[arr[i][1]]; // select right batch
+                        else if (current.ItemTask.Item is Experiment)
+                            current = current.ChildHiveTasks[arr[i][0]]; // select right sub task from experiment
+                    }
+                }
             }
         }
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveClientWeb.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveClientWeb.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveClientWeb.cs	(revision 13712)
@@ -36,4 +36,5 @@
 using HeuristicLab.Clients.Common.Properties;
 using Microsoft.AspNet.Hosting;
+using HeuristicLab.Clients.Hive.WebJobManager.Services.Imports;
 
 namespace HeuristicLab.Clients.Hive.WebJobManager
@@ -320,5 +321,8 @@
                 }
 
-
+                foreach (OptimizerHiveTask hiveJob in refreshableJob.HiveTasks.OfType<OptimizerHiveTask>())
+                {
+                    hiveJob.SetIndexInParentOptimizerList(null);
+                }
 
                 // upload Job
@@ -486,5 +490,5 @@
             var hiveExperiment = refreshableJob.Job;
             refreshableJob.IsProgressing = true;
-            TaskDownloader downloader = null;
+            TaskDownloaderWeb downloader = null;
 
             try
@@ -499,5 +503,5 @@
 
                 refreshableJob.Progress.Status = "Downloading tasks...";
-                downloader = new TaskDownloader(allTasks.Select(x => x.Id));
+                downloader = new TaskDownloaderWeb(allTasks.Select(x => x.Id));
                 downloader.StartAsync();
 
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveServiceLocatorWebManagerService.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveServiceLocatorWebManagerService.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/HiveServiceLocatorWebManagerService.cs	(revision 13712)
@@ -149,4 +149,15 @@
             binding.AllowCookies = false;
 
+            binding.ReaderQuotas.MaxDepth = 32;
+            binding.ReaderQuotas.MaxStringContentLength = 200000000;
+            binding.ReaderQuotas.MaxArrayLength = 200000000;
+            binding.ReaderQuotas.MaxBytesPerRead = 4096;
+            binding.ReaderQuotas.MaxNameTableCharCount = 16384;
+
+            binding.ReliableSession.Ordered = true;
+            binding.ReliableSession.InactivityTimeout = TimeSpan.Parse("00:10:00");
+            binding.ReliableSession.Enabled = false;
+
+
             binding.Security.Mode = SecurityMode.Message;
             binding.Security.Message.ClientCredentialType = MessageCredentialType.UserName;
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/ConcurrentTaskDownloaderWeb.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/ConcurrentTaskDownloaderWeb.cs	(revision 13712)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/ConcurrentTaskDownloaderWeb.cs	(revision 13712)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.Hive;
+
+namespace HeuristicLab.Clients.Hive.WebJobManager.Services.Imports
+{
+  /// <summary>
+  /// Downloads and deserializes jobs. It avoids too many jobs beeing downloaded or deserialized at the same time to avoid memory problems
+  /// </summary>
+  public class ConcurrentTaskDownloaderWeb<T> : IDisposable where T : class, ITask {
+    private bool abort = false;
+    // use semaphore to ensure only few concurrenct connections and few SerializedJob objects in memory
+    private Semaphore downloadSemaphore;
+    private Semaphore deserializeSemaphore;
+
+    public ConcurrentTaskDownloaderWeb(int concurrentDownloads, int concurrentDeserializations) {
+      downloadSemaphore = new Semaphore(concurrentDownloads, concurrentDownloads);
+      deserializeSemaphore = new Semaphore(concurrentDeserializations, concurrentDeserializations);
+    }
+
+    public void DownloadTaskData(Task t, Action<Task, T> onFinishedAction) {
+      Task<Tuple<Task, T>> task = Task<Tuple<Task, TaskData>>.Factory.StartNew(DownloadTaskData, t)
+                                     .ContinueWith((y) => DeserializeTask(y.Result));
+
+      task.ContinueWith((x) => OnTaskFinished(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnRanToCompletion);
+      task.ContinueWith((x) => OnTaskFailed(x), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
+    }
+
+    public void DownloadTaskDataAndTask(Guid taskId, Action<Task, T> onFinishedAction) {
+      Task<Tuple<Task, T>> task = Task<Task>.Factory.StartNew(DownloadTask, taskId)
+                                     .ContinueWith((x) => DownloadTaskData(x.Result))
+                                     .ContinueWith((y) => DeserializeTask(y.Result));
+
+      task.ContinueWith((x) => OnTaskFinished(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnRanToCompletion);
+      task.ContinueWith((x) => OnTaskFailed(x), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
+    }
+
+    private void OnTaskFinished(Task<Tuple<Task, T>> task, Action<Task, T> onFinishedAction) {
+      onFinishedAction(task.Result.Item1, task.Result.Item2);
+    }
+    private void OnTaskFailed(Task<Tuple<Task, T>> task) {
+      task.Exception.Flatten().Handle((e) => { return true; });
+      OnExceptionOccured(task.Exception.Flatten());
+    }
+
+    private Task DownloadTask(object taskId) {
+      Task t = null;
+      HiveClientWeb.TryAndRepeat(() => {
+        t = HiveServiceLocatorWebManagerService.Instance.CallHiveService(s => s.GetTask((Guid)taskId));
+      }, Settings.Default.MaxRepeatServiceCalls, "Failed to download task.");
+      return t;
+    }
+
+    protected Tuple<Task, TaskData> DownloadTaskData(object taskId) {
+      return DownloadTaskData((Task)taskId);
+    }
+
+    protected Tuple<Task, TaskData> DownloadTaskData(Task task) {
+      downloadSemaphore.WaitOne();
+      TaskData result = null;
+      try {
+        if (abort) return null;
+        HiveClientWeb.TryAndRepeat(() => {
+          result = HiveServiceLocatorWebManagerService.Instance.CallHiveService(s => s.GetTaskData(task.Id));
+        }, Settings.Default.MaxRepeatServiceCalls, "Failed to download task data.");
+      }
+      finally {
+        downloadSemaphore.Release();
+      }
+      return new Tuple<Task, TaskData>(task, result);
+    }
+
+    protected Tuple<Task, T> DeserializeTask(Tuple<Task, TaskData> taskData) {
+      deserializeSemaphore.WaitOne();
+      try {
+        if (abort || taskData.Item2 == null || taskData.Item1 == null) return null;
+        var deserializedJob = PersistenceUtil.Deserialize<T>(taskData.Item2.Data);
+        taskData.Item2.Data = null; // reduce memory consumption.
+        return new Tuple<Task, T>(taskData.Item1, deserializedJob);
+      }
+      finally {
+        deserializeSemaphore.Release();
+      }
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+
+    #region IDisposable Members
+    public void Dispose() {
+      deserializeSemaphore.Dispose();
+      downloadSemaphore.Dispose();
+    }
+    #endregion
+  }
+}
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/TaskDownloaderWeb.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/TaskDownloaderWeb.cs	(revision 13712)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Imports/TaskDownloaderWeb.cs	(revision 13712)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive.WebJobManager.Services.Imports {
+  public class TaskDownloaderWeb : IDisposable {
+    private IEnumerable<Guid> taskIds;
+    private ConcurrentTaskDownloaderWeb<ItemTask> taskDownloader;
+    private IDictionary<Guid, HiveTask> results;
+    private bool exceptionOccured = false;
+    private Exception currentException;
+    private ReaderWriterLockSlim resultsLock = new ReaderWriterLockSlim();
+
+    public bool IsFinished {
+      get {
+        try {
+          resultsLock.EnterReadLock();
+          return results.Count == taskIds.Count();
+        }
+        finally { resultsLock.ExitReadLock(); }
+      }
+    }
+
+    public bool IsFaulted {
+      get {
+        return exceptionOccured;
+      }
+    }
+
+    public Exception Exception {
+      get {
+        return currentException;
+      }
+    }
+
+    public int FinishedCount {
+      get {
+        try {
+          resultsLock.EnterReadLock();
+          return results.Count;
+        }
+        finally { resultsLock.ExitReadLock(); }
+      }
+    }
+
+    public IDictionary<Guid, HiveTask> Results {
+      get {
+        try {
+          resultsLock.EnterReadLock();
+          return results;
+        }
+        finally { resultsLock.ExitReadLock(); }
+      }
+    }
+
+    public TaskDownloaderWeb(IEnumerable<Guid> jobIds) {
+      taskIds = jobIds;
+      taskDownloader = new ConcurrentTaskDownloaderWeb<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
+      taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      results = new Dictionary<Guid, HiveTask>();
+    }
+
+    public void StartAsync() {
+      foreach (Guid taskId in taskIds) {
+        taskDownloader.DownloadTaskDataAndTask(taskId,
+          (localTask, itemTask) => {
+            if (localTask != null && itemTask != null) {
+              HiveTask hiveTask = itemTask.CreateHiveTask();
+              hiveTask.Task = localTask;
+              try {
+                resultsLock.EnterWriteLock();
+                results.Add(localTask.Id, hiveTask);
+              }
+              finally { resultsLock.ExitWriteLock(); }
+            }
+          });
+      }
+    }
+
+    private void taskDownloader_ExceptionOccured(object sender, EventArgs<Exception> e) {
+      OnExceptionOccured(e.Value);
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      exceptionOccured = true;
+      currentException = exception;
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+
+    #region IDisposable Members
+    public void Dispose() {
+      taskDownloader.ExceptionOccured -= new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      resultsLock.Dispose();
+      taskDownloader.Dispose();
+    }
+    #endregion
+  }
+}
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/JobViewModel.cs
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/JobViewModel.cs	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/JobViewModel.cs	(revision 13712)
@@ -8,9 +8,9 @@
     public class JobViewModel
     {
-        public List<Job> userJobs { get; set; }
+        public List<RefreshableJob> userJobs { get; set; }
 
-        public List<LightweightTask> lightJobTasks { get; set; }
-        public List<Task> filledJobTasks { get; set; }
-        public Job selectedJob { get; set; }
+        public RefreshableJob selectedJob { get; set; }
+
+        public List<HiveTask> selectedHiveTasks { get; set; }
         public string message { get; set; }
         public JobViewModel()
@@ -18,5 +18,5 @@
             userJobs = null;
             selectedJob = null;
-            filledJobTasks = new List<Task>();
+            selectedHiveTasks = new List<HiveTask>();
             message = "";
         }
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13712)
@@ -18,5 +18,5 @@
         </a>
     </div>
-    <div class="row" style="padding:10px">
+    <div class="row" style="padding:10px; margin-right:0px!important">
         @if (Model.userJobs.Count == 0)
         {
@@ -34,7 +34,8 @@
                            asp-controller="Job"
                            asp-action="Selected"
-                           asp-route-id="@job.Id">
-                            @job.Name - @job.DateCreated
-                            <span class="badge">@job.JobCount</span>
+                           asp-route-id="@job.Id"
+                           onclick="showLoader()">
+                            @job.Job.Name - @job.Job.DateCreated
+                            <span class="badge">@job.Job.JobCount</span>
                         </a>
                     }
@@ -42,20 +43,25 @@
                 </div>
             </div>
+            <p style="display:none" id="loader" class="text-center">
+                <br /><br /><br /><br /><br /><br /><br />
+                <i class="fa fa-cog fa-spin fa-5x" id="spinner">
+                </i>
+            </p>
             @if (Model.selectedJob != null)
             {
-                <div class="col-sm-8" style="padding:5px; padding-left:10px;">
+                <div class="col-sm-8" id="content" style="padding:5px; padding-left:10px;">
                     <div class="row">
                         <h2 style="padding-left:20px">
-                            @Model.selectedJob.Name
+                            @Model.selectedJob.Job.Name
                             <a onclick="popUpDelete()"
-                               style="margin-bottom:10px;" 
-                               
+                               style="margin-bottom:10px;"
                                class='btn btn-danger'>
                                 <span class="glyphicon glyphicon-trash" aria-hidden="true"></span>
                             </a>
-                            <a style="display:none" 
-                               asp-action="Delete" 
-                               asp-route-id="@Model.selectedJob.Id" 
-                               asp-controller="Job" id="del"  ></a>
+                            <a style="display:none"
+                               asp-action="Delete"
+                               asp-route-id="@Model.selectedJob.Id"
+                               asp-controller="Job" id="del"
+                               onclick="showDeleter()"></a>
 
                             <script type="text/javascript">
@@ -67,42 +73,28 @@
                                 }
                             </script>
-            
+
                         </h2>
                         <div class="col-sm-6" style="padding-left:30px">
-                            <p>Description: @Model.selectedJob.Description</p>
-                            <p>Resources: @Model.selectedJob.ResourceNames</p>
-                            <p>Created: @Model.selectedJob.DateCreated</p>
-                            <p>Owned by: @Model.selectedJob.OwnerUsername</p>
+                            <p>Description: @Model.selectedJob.Job.Description</p>
+                            <p>Resources: @Model.selectedJob.Job.ResourceNames</p>
+                            <p>Created: @Model.selectedJob.Job.DateCreated</p>
+                            <p>Owned by: @Model.selectedJob.Job.OwnerUsername</p>
 
                         </div>
                         <div class="col-sm-6" style="padding-left:30px">
-                            <p>Calculating: @Model.selectedJob.CalculatingCount</p>
-                            <p>Finished: @Model.selectedJob.FinishedCount</p>
+                            <p>Calculating: @Model.selectedJob.Job.CalculatingCount</p>
+                            <p>Finished: @Model.selectedJob.Job.FinishedCount</p>
                         </div>
 
                     </div>
                     <div class="row">
-                        <h3 style="padding-left:20px">@Model.lightJobTasks.Count Task@(Model.lightJobTasks != null && Model.lightJobTasks.Count != 1 ? "s" : "" )</h3>
-                        @foreach (var task in Model.lightJobTasks)
+                        <h3 style="padding-left:20px">Tasks</h3>
+                        <script type="text/javascript">
+                            //TODO Globale variabele waar data per categorie in gestoken kan worden 
+                        </script>
+                        @foreach (var task in Model.selectedJob.HiveTasks)
                         {
-                            <table class="table " 
-                                   style="margin-left:20px;">
-                                <thead>
-                                    <tr>
-                                        <th>@task</th>
-                                    </tr>
-                                </thead>
-                                <tbody>
-                                    <tr>
-                                        <td>Last update @task.LastTaskDataUpdate</td>
-                                        <td>State: @task.State</td>
-                                        
-                                    </tr>
-                                    <tr>
-                                        <td>@task.ExecutionTime executed</td>
-                                        <td>Created: @task.DateCreated</td>
-                                    </tr>
-                                </tbody>
-                            </table>
+                            @Html.Partial("SelectedJobPartials/_TaskPartial",
+                           new HeuristicLab.Clients.Hive.WebJobManager.Models.HiveTaskContainer(task))
 
                         }
@@ -111,4 +103,15 @@
             }
         }
+        <script type="text/javascript">
+            function showLoader() {
+                document.getElementById("loader").style.display = "";
+                document.getElementById("content").style.display = "none";
+            }
+            function showDeleter() {
+                document.getElementById("loader").style.display = "";
+                document.getElementById("content").style.display = "none";
+                document.getElementById("spinner").className = "fa fa-trash-o fa-spin fa-5x";
+            }
+        </script>
     </div>
 </div>
Index: /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Algorithm.cshtml
===================================================================
--- /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Algorithm.cshtml	(revision 13711)
+++ /branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Algorithm.cshtml	(revision 13712)
@@ -1,4 +1,5 @@
 ﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.FileOpeningViewModel
-
+@{System.Random randomizer = new Random();
+    int randy = randomizer.Next(5000); }
 
 
@@ -8,9 +9,28 @@
     </div>
     <div class="row" style="text-align:left">
-        <h1 data-toggle="tooltip" title=" @Model.SelectedTask.ItemTask.ItemName
-            @Model.SelectedTask.ItemTask.Description ">
+        <h1 data-toggle="tooltip" title="@Model.SelectedTask.ItemTask.ItemName
+            @Model.SelectedTask.ItemTask.Description">
             <span class="label label-primary">Algorithm: @Model.SelectedTask.ItemTask.Name</span>
         </h1>
         <a class="btn btn-success" id="fakehiveadd" onclick="addtoHive()">Add to Hive</a>
+
+        <div class="btn-group">
+            <button 
+                    type="button" 
+                    id="prior@(randy)"
+                    class="btn btn-info dropdown-toggle" 
+                    data-toggle="dropdown" 
+                    aria-haspopup="true" aria-expanded="false">
+                Normal <span class="caret"></span>
+            </button>
+            <ul class="dropdown-menu">
+                <li><a onclick="changePriority([],0,@randy)">Low</a></li>
+                <li><a onclick="changePriority([],1,@randy)">Normal</a></li>
+                <li><a onclick="changePriority([],2,@randy)">Urgent</a></li>
+                <li><a onclick="changePriority([],3,@randy)">Critical</a></li>
+            </ul>
+        </div>
+
+
         <a class="btn btn-success" id="realhiveadd" asp-controller="Job" asp-action="AddToHive" style="display:none"></a>
         <h4 id="result" style="display:none">Start uploading algorithm...</h4>
@@ -24,4 +44,5 @@
         </div>
     </div>
+
     <div class="row">
         <div class="btn-group-justified">
